/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Client - TestUserProperties.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.config;

import java.util.ArrayList;
import java.util.List;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

@Component
@ConfigurationProperties(prefix = "dlcm.test")
public class TestUserProperties {

  public static class TestUser {
    private String name;

    public String getName() {
      return this.name;
    }

    public void setName(final String name) {
      this.name = name;
    }
  }

  private List<TestUser> users = new ArrayList<>();

  public List<TestUser> getUsers() {
    return this.users;
  }

  public void setUser(List<TestUser> userList) {
    this.users = userList;
  }
}
