/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Client - ResourceClientServiceInterface.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.service;

import java.util.List;
import java.util.Map;

import ch.unige.solidify.rest.Resource;

public interface ResourceClientServiceInterface<T extends Resource> {
  T create(T resource);

  void delete(String resId);

  void deleteList(String[] ids);

  List<T> findAll();

  T findOne(String resId);

  List<T> searchByProperties(Map<String, String> properties);

  T update(String resId, T resource);

  /**
   * Send an update request containing only the values corresponding to propertiesToUpdate
   *
   * @param resId
   * @param resource
   * @param propertiesToUpdate
   * @return
   */
  T update(String resId, T resource, List<String> propertiesToUpdate);
}
