/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Client - OAISetClientService.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.service.access;

import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Service;

import ch.unige.solidify.OAIConstants;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.model.oai.OAISet;
import ch.unige.solidify.rest.ActionName;

import ch.dlcm.service.ResourceClientService;

@Service
public class OAISetClientService extends ResourceClientService<OAISet> {

  private static final String OAI_SET_PATH = SolidifyConstants.URL_SEP + OAIConstants.OAI_SETS;

  public OAISetClientService() {
    super(OAI_SET_PATH, OAISet.class, OAIConstants.OAI_MODULE);
  }

  @Override
  public List<OAISet> findAll() {
    return this.findAll(OAISet.class);
  }

  public OAISet save(String resId) {
    return this.doActionOnId(resId, ActionName.SAVE);
  }

  @Override
  public List<OAISet> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, OAISet.class);
  }
}
