/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Client - ArchiveACLClientService.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.service.admin;

import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Service;

import ch.unige.solidify.SolidifyConstants;

import ch.dlcm.model.settings.ArchiveACL;
import ch.dlcm.rest.ModuleName;
import ch.dlcm.rest.ResourceName;
import ch.dlcm.service.ResourceClientService;

@Service
public class ArchiveACLClientService extends ResourceClientService<ArchiveACL> {

  private static final String ARCHIVE_ACL_PATH = SolidifyConstants.URL_SEP + ResourceName.ARCHIVE_ACL;

  public ArchiveACLClientService() {
    super(ARCHIVE_ACL_PATH, ArchiveACL.class, ModuleName.ADMIN);
  }

  @Override
  public List<ArchiveACL> findAll() {
    return this.findAll(ArchiveACL.class);
  }

  @Override
  public List<ArchiveACL> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, ArchiveACL.class);
  }

}
