/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Client - IndexFieldAliasClientService.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.service.datamgmt;

import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Service;

import ch.unige.solidify.IndexConstants;
import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.model.index.IndexFieldAlias;

import ch.dlcm.service.ResourceClientService;

@Service
public class IndexFieldAliasClientService extends ResourceClientService<IndexFieldAlias> {

  private static final String INDEX_FIELD_ALIAS_PATH = SolidifyConstants.URL_SEP + IndexConstants.INDEX_FIELD_ALIASES;

  public IndexFieldAliasClientService() {
    super(INDEX_FIELD_ALIAS_PATH, IndexFieldAlias.class, IndexConstants.INDEX_MODULE);
  }

  @Override
  public List<IndexFieldAlias> findAll() {
    return this.findAll(IndexFieldAlias.class);
  }

  @Override
  public List<IndexFieldAlias> searchByProperties(Map<String, String> properties) {
    return this.searchByProperties(properties, IndexFieldAlias.class);
  }
}
