/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Integration Tests - ArchiveTypeAsAdminIT.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.test.admin;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Test;

import ch.dlcm.model.settings.ArchiveType;
import ch.dlcm.test.DLCMTestConstants;

class ArchiveTypeAsAdminIT extends AbstractAdminIT {

  @Override
  protected void setUser() {
    this.restClientTool.sudoAdmin();
  }

  @Test
  void creationTest() {
    final ArchiveType archiveType1 = new ArchiveType();
    archiveType1.setMasterType(this.archiveTypeService.findOne(ArchiveType.DATASET_ID));
    archiveType1.setTypeName(DLCMTestConstants.getRandomNameWithTemporaryLabel("Archive Type for Testing"));
    final ArchiveType archiveType2 = this.archiveTypeService.create(archiveType1);

    // Test the creation
    assertEquals(archiveType1.getMasterType().getTypeName(), archiveType2.getMasterType().getTypeName());
    assertEquals(archiveType1.getTypeName(), archiveType2.getTypeName());
  }

  @Override
  protected void deleteFixtures() {
    this.clearArchiveTypeFixtures();
  }

}
