/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Integration Tests - ArchivesDemoIT.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.test.demo;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.MethodOrderer;
import org.junit.jupiter.api.Order;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.TestMethodOrder;
import org.springframework.beans.factory.annotation.Qualifier;

import ch.dlcm.service.archivalstorage.AIPClientServiceSecondStorage;

@Order(9)
@TestMethodOrder(MethodOrderer.OrderAnnotation.class)
@Disabled(DLCMDemoConstants.DEMO_MESSAGE)
class ArchivesDemoIT extends AbstractCheckDemoIT {

  public ArchivesDemoIT(@Qualifier("AIPClientServiceForSecondStorage") AIPClientServiceSecondStorage aipService2) {
    super(aipService2);
  }

  @Order(1)
  @Test
  void checkBodmerDeposits() {
    checkDeposits(DLCMDemoConstants.BODMER_ORG_UNIT);
  }

  @Order(2)
  @Test
  void checkBodmerSIP() {
    checkSIP(DLCMDemoConstants.BODMER_ORG_UNIT);
  }

  @Order(3)
  @Test
  void checkBodmerAIPOnMainStorage() {
    checkAIPOnMainStorage(DLCMDemoConstants.BODMER_ORG_UNIT);
  }

  @Order(4)
  @Test
  void checkBodmerAIPOnReplicaStorage() {
    checkAIPOnReplicaStorage(DLCMDemoConstants.BODMER_ORG_UNIT);
  }

  @Order(5)
  @Test
  void checkBodmerArchives() {
    checkArchives(DLCMDemoConstants.BODMER_ORG_UNIT);
  }

  @Order(6)
  @Test
  void checkDlcmDeposits() {
    checkDeposits(DLCMDemoConstants.DLCM_ORG_UNIT);
  }

  @Order(7)
  @Test
  void checkDlcmSIP() {
    checkSIP(DLCMDemoConstants.DLCM_ORG_UNIT);
  }

  @Order(8)
  @Test
  void checkDlcmAIPOnMainStorage() {
    checkAIPOnMainStorage(DLCMDemoConstants.DLCM_ORG_UNIT);
  }

  @Order(9)
  @Test
  void checkDlcmAIPOnReplicaStorage() {
    checkAIPOnReplicaStorage(DLCMDemoConstants.DLCM_ORG_UNIT);
  }

  @Order(10)
  @Test
  void checkDlcmArchives() {
    checkArchives(DLCMDemoConstants.DLCM_ORG_UNIT);
  }

}
