/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Model - AuthorizedOrganizationalUnitDto.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.model.dto;

import ch.dlcm.model.security.Role;
import ch.dlcm.model.settings.OrganizationalUnit;

public class AuthorizedOrganizationalUnitDto extends OrganizationalUnit {

  private Role role;

  public Role getRole() {
    return role;
  }

  public void setRole(Role role) {
    this.role = role;
  }

  public static AuthorizedOrganizationalUnitDto fromEntity(OrganizationalUnit organizationalUnit) {
    AuthorizedOrganizationalUnitDto orgUnitDto = new AuthorizedOrganizationalUnitDto();
    orgUnitDto.setResId(organizationalUnit.getResId());
    orgUnitDto.setName(organizationalUnit.getName());
    orgUnitDto.setClosingDate(organizationalUnit.getClosingDate());
    orgUnitDto.setDefaultDisseminationPolicy(organizationalUnit.getDefaultDisseminationPolicy());
    orgUnitDto.setDefaultLicense(organizationalUnit.getDefaultLicense());
    orgUnitDto.setDefaultPreservationPolicy(organizationalUnit.getDefaultPreservationPolicy());
    orgUnitDto.setDefaultSubmissionPolicy(organizationalUnit.getDefaultSubmissionPolicy());
    orgUnitDto.setDescription(organizationalUnit.getDescription());
    orgUnitDto.setIsEmpty(organizationalUnit.getIsEmpty());
    orgUnitDto.setKeywords(organizationalUnit.getKeywords());
    orgUnitDto.setOpeningDate(organizationalUnit.getOpeningDate());
    orgUnitDto.setUrl(organizationalUnit.getUrl());
    orgUnitDto.setLogo(organizationalUnit.getLogo());
    return orgUnitDto;

  }
}
