/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Model - UrlPath.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.rest;

import ch.unige.solidify.SolidifyConstants;
import ch.unige.solidify.rest.ActionName;

public final class UrlPath {

  // ==========
  // Access
  // ==========
  public static final String ACCESS = SolidifyConstants.URL_SEP + ModuleName.ACCESS;

  // @formatter:off

  public static final String ACCESS_AIP = ACCESS + SolidifyConstants.URL_SEP + ResourceName.AIP;
  public static final String ACCESS_ALL_METADATA = ACCESS + SolidifyConstants.URL_SEP + ResourceName.ALL_METADATA;
  public static final String ACCESS_DIP = ACCESS + SolidifyConstants.URL_SEP + ResourceName.DIP;

  public static final String ACCESS_ORDER = ACCESS + SolidifyConstants.URL_SEP + ResourceName.ORDER;
  public static final String ACCESS_ORG_UNIT= ACCESS + SolidifyConstants.URL_SEP + ResourceName.ORG_UNIT;
  public static final String ACCESS_PRIVATE_METADATA = ACCESS + SolidifyConstants.URL_SEP + ResourceName.PRIVATE_METADATA;
  public static final String ACCESS_PUBLIC_METADATA = ACCESS + SolidifyConstants.URL_SEP + ResourceName.PUBLIC_METADATA;
  // ==========
  // Admin
  // ==========
  public static final String ADMIN = SolidifyConstants.URL_SEP + ModuleName.ADMIN;

  public static final String ADMIN_AUTHORIZED_UNIT = ADMIN + SolidifyConstants.URL_SEP + ResourceName.AUTHORIZED_ORG_UNIT;
  public static final String ADMIN_DISSEMINATION_POLICY = ADMIN + SolidifyConstants.URL_SEP + ResourceName.DIS_POLICY;
  public static final String ADMIN_FUNDING_AGENCY = ADMIN + SolidifyConstants.URL_SEP + ResourceName.FUNDING_AGENCY;
  public static final String ADMIN_INSTITUTION = ADMIN + SolidifyConstants.URL_SEP + ResourceName.INSTITUTION;
  public static final String ADMIN_LANGUAGE = ADMIN + SolidifyConstants.URL_SEP + ResourceName.LANGUAGE;
  public static final String ADMIN_LICENSE = ADMIN + SolidifyConstants.URL_SEP + ResourceName.LICENSE;
  public static final String ADMIN_LICENSE_IMPORT_FILE = SolidifyConstants.URL_SEP + ActionName.IMPORT + SolidifyConstants.URL_SEP + ActionName.FILE;
  public static final String ADMIN_LICENSE_IMPORT_LIST = SolidifyConstants.URL_SEP + ActionName.IMPORT + SolidifyConstants.URL_SEP + ActionName.LIST;
  public static final String ADMIN_METADATA_TYPE = ADMIN + SolidifyConstants.URL_SEP + ResourceName.METADATA_TYPE;
  public static final String ADMIN_NOTIFICATION = ADMIN + SolidifyConstants.URL_SEP + ResourceName.NOTIFICATION;
  public static final String ADMIN_OPEN_LICENSE_IMPORT_FILE = SolidifyConstants.URL_SEP + ActionName.IMPORT + "/open-license/" + ActionName.FILE;
  public static final String ADMIN_PERSON = ADMIN + SolidifyConstants.URL_SEP + ResourceName.PERSON;
  public static final String ADMIN_PRESERVATION_POLICY = ADMIN + SolidifyConstants.URL_SEP + ResourceName.PRES_POLICY;
  public static final String ADMIN_RESEARCH_DOMAIN = ADMIN + SolidifyConstants.URL_SEP + ResourceName.RESEARCH_DOMAIN;
  public static final String ADMIN_ROLE = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ROLE;
  public static final String ADMIN_SUBMISSION_AGREEMENT = ADMIN + SolidifyConstants.URL_SEP + ResourceName.SUBMISSION_AGREEMENT;
  public static final String ADMIN_SUBMISSION_POLICY = ADMIN + SolidifyConstants.URL_SEP + ResourceName.SUB_POLICY;
  public static final String ADMIN_UNIT = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ORG_UNIT;
  public static final String ADMIN_USER = ADMIN + SolidifyConstants.URL_SEP + ResourceName.USER;
  public static final String ADMIN_SYSTEM_PROPERTY = ADMIN + SolidifyConstants.URL_SEP + ResourceName.SYSTEM_PROPERTY;
  public static final String ADMIN_ROLE_APPLICATION = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ROLE_APPLICATION;
  public static final String ADMIN_ARCHIVE_STATISTICS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ARCHIVE_STATISTICS;
  public static final String ADMIN_ARCHIVE_ACL = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ARCHIVE_ACL;
  public static final String ADMIN_ARCHIVE_RATING = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ARCHIVE_RATING;
  public static final String ADMIN_RATING_TYPE = ADMIN + SolidifyConstants.URL_SEP + ResourceName.RATING_TYPE;
  public static final String ADMIN_OAUTH2_CLIENT = ADMIN + SolidifyConstants.URL_SEP + ResourceName.OAUTH2_CLIENT;
  public static final String ADMIN_SCHEDULED_TASKS = ADMIN + SolidifyConstants.URL_SEP + ResourceName.SCHEDULED_TASKS;
  public static final String ADMIN_ARCHIVE_TYPE = ADMIN + SolidifyConstants.URL_SEP + ResourceName.ARCHIVE_TYPE;
  public static final String ADMIN_GLOBAL_BANNER = ADMIN + SolidifyConstants.URL_SEP + ResourceName.GLOBAL_BANNER;

  // ================
  // Archival Storage
  // ================
  public static final String ARCHIVAL_STORAGE = SolidifyConstants.URL_SEP + ModuleName.ARCHIVALSTORAGE;
  public static final String ARCHIVAL_STORAGE_AIP = ARCHIVAL_STORAGE + SolidifyConstants.URL_SEP + ResourceName.AIP;
  public static final String ARCHIVAL_STORAGE_STORED_AIP = ARCHIVAL_STORAGE + SolidifyConstants.URL_SEP + ResourceName.STORED_AIP;
  // =====================
  // Authorization Server
  // =====================
  public static final String AUTH = SolidifyConstants.URL_SEP + ModuleName.AUTH;
  public static final String AUTH_AUTHORIZE = AUTH + SolidifyConstants.URL_SEP + DLCMActionName.AUTHORIZE;
  public static final String AUTH_CHECK_TOKEN = AUTH + SolidifyConstants.URL_SEP + DLCMActionName.CHECK_TOKEN;
  public static final String AUTH_SHIBLOGIN = SolidifyConstants.URL_SEP + ResourceName.LOGIN;
  public static final String AUTH_TOKEN = AUTH + SolidifyConstants.URL_SEP + DLCMActionName.TOKEN;
  public static final String AUTH_USER_ID = "{" + DLCMActionName.USER_ID + "}";
  // ==========
  // Data Mgmt
  // ==========
  public static final String DATA_MGMT = SolidifyConstants.URL_SEP + ModuleName.DATAMGMT;
  public static final String DATA_MGMT_DI = DATA_MGMT + SolidifyConstants.URL_SEP + ResourceName.DI;
  public static final String DATA_MGMT_ITEM = DATA_MGMT + SolidifyConstants.URL_SEP + ResourceName.ITEM;
  public static final String DATA_MGMT_PRIVATE_DI = DATA_MGMT + SolidifyConstants.URL_SEP + ResourceName.DI_PRIVATE;
  public static final String DATA_MGMT_PUBLIC_DI = DATA_MGMT + SolidifyConstants.URL_SEP + ResourceName.DI_PUBLIC;
  public static final String DATA_MGMT_ARCHIVE_THUMBNAIL = DATA_MGMT + SolidifyConstants.URL_SEP + ResourceName.ARCHIVE_THUMBNAIL;
  // ==========
  // Ingest
  // ==========
  public static final String INGEST = SolidifyConstants.URL_SEP + ModuleName.INGEST;
  public static final String INGEST_SIP = INGEST + SolidifyConstants.URL_SEP + ResourceName.SIP;
  // ==========
  // Pre-ingest
  // ==========
  public static final String PREINGEST = SolidifyConstants.URL_SEP + ModuleName.PREINGEST;
  public static final String PREINGEST_CONTRIBUTOR = PREINGEST + SolidifyConstants.URL_SEP + ResourceName.CONTRIBUTOR;
  public static final String PREINGEST_DEPOSIT = PREINGEST + SolidifyConstants.URL_SEP + ResourceName.DEPOSIT;
  // ======================
  // Preservation Planning
  // ======================
  public static final String PRES_PLANNING = SolidifyConstants.URL_SEP + ModuleName.PRES_PLANNING;
  public static final String PRES_PLANNING_AIP = PRES_PLANNING + SolidifyConstants.URL_SEP + ResourceName.AIP;

  // @formatter on

  public static final String PRES_PLANNING_MODULE = PRES_PLANNING + SolidifyConstants.URL_SEP + ResourceName.MODULE;
  public static final String PRES_PLANNING_MONITOR = PRES_PLANNING + SolidifyConstants.URL_SEP + ResourceName.MONITOR;
  public static final String PRES_PLANNING_PRES_JOB = PRES_PLANNING + SolidifyConstants.URL_SEP + ResourceName.PRES_JOB;
  // ================
  // Resource Server
  // ================
  public static final String RES_SRV = SolidifyConstants.URL_SEP + ModuleName.RES_SRV;
  private UrlPath() {
    throw new IllegalStateException(SolidifyConstants.TOOL_CLASS);
  }

}
