/*-
 * %%----------------------------------------------------------------------------------------------
 * DLCM Technology - DLCM Solution - ArchiveStatisticsDoc.java
 * SPDX-License-Identifier: GPL-2.0-or-later
 * %----------------------------------------------------------------------------------------------%
 * Copyright (C) 2017 - 2022 University of Geneva
 * %----------------------------------------------------------------------------------------------%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/gpl-2.0.html>.
 * ----------------------------------------------------------------------------------------------%%
 */

package ch.dlcm.test.resource;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.springframework.restdocs.payload.FieldDescriptor;

import ch.unige.solidify.test.helper.AbstractResourceDoc;
import ch.unige.solidify.test.helper.FieldDescriptorBuilder;
import ch.unige.solidify.test.model.TypeField;

import ch.dlcm.model.settings.ArchiveStatistics;
import ch.dlcm.rest.DLCMActionName;
import ch.dlcm.rest.UrlPath;

public class ArchiveStatisticsDoc extends AbstractResourceDoc {

  @Override
  public String getModelName() {
    return getCamelCase(ArchiveStatistics.class.getSimpleName());
  }

  @Override
  public List<String> getListLinks() {
    return Collections.emptyList();
  }

  @Override
  public String getName() {
    return UrlPath.ADMIN_ARCHIVE_STATISTICS;
  }

  @Override
  public List<String> getResourceLinks() {
    return Arrays.asList(DLCMActionName.ADD_VIEW, DLCMActionName.ADD_DOWNLOAD, DLCMActionName.STATISTICS);
  }

  @Override
  protected List<FieldDescriptor> getDocumentationFields() {
    // @formatter:off
    return new ArrayList<>(Arrays.asList(
      new FieldDescriptorBuilder(this)
        .name("viewNumber")
        .description("The view number of the archive")
        .type(TypeField.INT32)
        .build(),
      new FieldDescriptorBuilder(this)
        .name("downloadNumber")
        .description("The download number of the archive")
        .type(TypeField.INT32)
        .build()));
    // @formatter:on
  }

}
